//(c)Dharma Shukla(dharmashukla@hotmail.com)
// SuperRadio.h : Declaration of the CSuperRadio

#ifndef __SUPERRADIO_H_
#define __SUPERRADIO_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include "RadioButtonProjCP.h"




class ATL_NO_VTABLE CSuperRadio : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatch,
	public CComControl<CSuperRadio>,
	public IPersistStreamInitImpl<CSuperRadio>,
	public IOleControlImpl<CSuperRadio>,
	public IOleObjectImpl<CSuperRadio>,
	public IOleInPlaceActiveObjectImpl<CSuperRadio>,
	public IViewObjectExImpl<CSuperRadio>,
	public IOleInPlaceObjectWindowlessImpl<CSuperRadio>,
	public IConnectionPointContainerImpl<CSuperRadio>,
	public IPersistStorageImpl<CSuperRadio>,
	public ISpecifyPropertyPagesImpl<CSuperRadio>,
	public IQuickActivateImpl<CSuperRadio>,
	public IDataObjectImpl<CSuperRadio>,
	public IProvideClassInfo2Impl<&CLSID_SuperRadio, &DIID__ISuperRadioEvents, &LIBID_RADIOBUTTONPROJLib>,
	public IPropertyNotifySinkCP<CSuperRadio>,
	public CComCoClass<CSuperRadio, &CLSID_SuperRadio>,
	public CProxy_ISuperRadioEvents< CSuperRadio >
{
public:
	CContainedWindow m_ctlButton;
	
	CSuperRadio() :	m_ctlButton(_T("Button"), this, 1),m_bValue(VARIANT_FALSE)
	{
		m_bWindowOnly = TRUE;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SUPERRADIO)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSuperRadio)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CSuperRadio)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("Value", 0, GUID_NULL)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CSuperRadio)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
	CONNECTION_POINT_ENTRY(DIID__ISuperRadioEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CSuperRadio)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	CHAIN_MSG_MAP(CComControl<CSuperRadio>)
ALT_MSG_MAP(1)
	MESSAGE_HANDLER(WM_LBUTTONUP,OnFocus)
	MESSAGE_HANDLER(WM_SETFOCUS, OnFocus)
END_MSG_MAP()

/*---------------------------------------------------------------------------------------------------------*/
	LRESULT OnFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		if(!m_bValue)
			put_Value(VARIANT_TRUE);
		bHandled = FALSE;
		return 0L;
	}
/*---------------------------------------------------------------------------------------------------------*/
	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		if(!IsChild(::GetFocus()))
		{
			m_ctlButton.SetFocus();
		}
		if (m_bInPlaceActive)
		{
			CComQIPtr<IOleControlSite, &IID_IOleControlSite> spSite(m_spClientSite);
			if (m_bInPlaceActive && spSite != NULL)
				spSite->OnFocus(TRUE);
		}
		bHandled = TRUE;
		return 0L;
	}
/*---------------------------------------------------------------------------------------------------------*/
	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		RECT rc;
		GetWindowRect(&rc);
		rc.right -= rc.left;
		rc.bottom -= rc.top;
		rc.top = rc.left = 0;
		
		m_ctlButton.Create(m_hWnd, rc,_T(""),WS_CHILDWINDOW| WS_OVERLAPPED|WS_CLIPSIBLINGS|WS_MAXIMIZEBOX | WS_VISIBLE | BS_RADIOBUTTON |BS_MULTILINE|WS_TABSTOP);
		m_ctlButton.SetWindowText(_T("Hello World"));

		return 0;
	}
/*---------------------------------------------------------------------------------------------------------*/
	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip)
	{
		IOleInPlaceObjectWindowlessImpl<CSuperRadio>::SetObjectRects(prcPos, prcClip);
		
		int cx, cy;
		cx = prcPos->right - prcPos->left;
		cy = prcPos->bottom - prcPos->top;
		
		::SetWindowPos(m_ctlButton.m_hWnd, NULL, 0,0, cx, cy, SWP_NOZORDER | SWP_NOACTIVATE);
		return S_OK;
	}

/*---------------------------------------------------------------------------------------------------------*/

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)


// ISuperRadio
public:
	STDMETHOD(get_Value)(/*[out, retval]*/ OLE_OPTEXCLUSIVE *pVal);
	STDMETHOD(put_Value)(/*[in]*/ OLE_OPTEXCLUSIVE newVal);

/*---------------------------------------------------------------------------------------------------------*/

public:
	OLE_OPTEXCLUSIVE m_bValue;
	CComPtr<ITypeInfo> m_spTypeInfo;


/*---------------------------------------------------------------------------------------------------------*/

public://IDispatch Implementation

	STDMETHOD(GetTypeInfoCount)(UINT* pctinfo)
	{
		if(!pctinfo) return E_POINTER;
	
		*pctinfo = 1;
		return S_OK;
	}

/*---------------------------------------------------------------------------------------------------------*/
	STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo** pptinfo)
	{
		if(!pptinfo) return E_POINTER;

		if(m_spTypeInfo.p)
		{
			*pptinfo = m_spTypeInfo.p;
			(*pptinfo)->AddRef();
			return S_OK;
		}
		return E_FAIL;
	}
/*---------------------------------------------------------------------------------------------------------*/

	STDMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames,LCID lcid, DISPID* rgdispid)
	{
		return m_spTypeInfo->GetIDsOfNames(rgszNames, cNames, rgdispid);
	}
/*---------------------------------------------------------------------------------------------------------*/

	STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid,LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult,EXCEPINFO* pexcepinfo, UINT* puArgErr)
	{
		if (riid != IID_NULL)
		{
			return DISP_E_UNKNOWNINTERFACE;
		}

		if(!pdispparams)
		{
			return E_POINTER;
		}

		if(dispidMember != DISPID_VALUE)//We support only one property
		{
			return DISP_E_MEMBERNOTFOUND;
		}
		
		//put
		if(	(dispidMember == DISPID_VALUE) && 
			(pdispparams->cArgs == 1) && 
			(*(pdispparams->rgdispidNamedArgs) == DISPID_PROPERTYPUT) &&
			(wFlags == DISPATCH_PROPERTYPUT) 
		 )
		{
			return put_Value(pdispparams->rgvarg[0].boolVal);
		}
		//get
		else if((dispidMember == DISPID_VALUE) && (pdispparams->cArgs == 0) )
		{
			::VariantInit(pvarResult);
			pvarResult->vt = VT_BOOL;
			return get_Value(&(pvarResult->boolVal));
		}

		return S_OK;
    }

/*---------------------------------------------------------------------------------------------------------*/
	
	HRESULT FinalRelease()
	{
		if(m_spTypeInfo.p)
		{
			m_spTypeInfo.Release();
			m_spTypeInfo = NULL;
		}
		return S_OK;
	}

/*---------------------------------------------------------------------------------------------------------*/

	HRESULT FinalConstruct()
	{
		CComPtr<ITypeLib> spTypeLib;
    	HRESULT hr = E_FAIL;
		
		if(SUCCEEDED(::LoadRegTypeLib(LIBID_RADIOBUTTONPROJLib,1,0,LANG_NEUTRAL, &spTypeLib)))
		{
   	      if(SUCCEEDED(spTypeLib->GetTypeInfoOfGuid(DIID__ISuperRadioProperties,&m_spTypeInfo)))
		  {
			hr = S_OK;
		  }
		  spTypeLib.Release();
		  spTypeLib = NULL;
		}
		return hr;   
	}
/*---------------------------------------------------------------------------------------------------------*/

};

#endif //__SUPERRADIO_H_
